/*
 * The C-style client side main routine calls the  add() function on
 * the remote rpc server
 */
#include <stdio.h>
#include "add.h"

int
main(int argc, char *argv[])
{
    CLIENT *clnt;
    int *result;
    add_arg arg;

    if(argc != 4) {
        printf("usage: %s host num1 num2\n", argv[0]);
        exit(1);
    }
    /* create client handle - bind to server */
    clnt = clnt_create(argv[1], ADDPROG, ADDVER, "udp");
    if (clnt == NULL) {
        clnt_pcreateerror(argv[1]);
        exit(1);
    }
    arg.first = atoi(argv[2]);
    arg.second = atoi(argv[3]);
    /*
     * invoke remote procedure: Note that multiple arguments can be
     * passed to add_l() instead of a pointer
     */
    result = add_1(&arg, clnt);
    if (result == (int *) NULL) {
        clnt_perror(clnt, "call failed:");
        exit(1);
    } else {
        printf("Success: %d + %d = %d\n", arg.first, arg.second, *result);
    }
    exit(0);
}
