#include <rpc/rpc.h>
#include <stdio.h>
#include "example1.h"
#include "localServerStub.h"

LocalServerStub::LocalServerStub(char *serverName) {

#ifdef DEBUG
    printf("LocalServerStub::LocalServerStub(char *serverName) %x\n", this);
#endif

//create client handle (connect to server)
            if ( (itsClientHandle = 
                  clnt_create(serverName, SERVERPROG, SERVERVERS, "tcp")) == NULL) {
// if couldn't create client handle (server not there) send error
                clnt_pcreateerror(serverName);
                exit(2);
            }

            //server is now ready, we can send requests
            //ask RemoteStub to create a remote Server class
#ifdef DEBUG
            printf("LocalServerStub::LocalServerStub(char *serverName) Calling remote proc new_server %x\n", this);
#endif         
  
//new_server_1(no arguments, client handle)
new_server_1(NULL, itsClientHandle); 

};

LocalServerStub::~LocalServerStub() {

#ifdef DEBUG
    printf("LocalServerStub::~LocalServerStub() %x\n", this);
#endif

    //ask RemoteServerStub to delete remote Server
    delete_server_1(NULL, itsClientHandle);
    //TODO : do we need to kill the RemoteStub?
}


int LocalServerStub::GetItsIntMember() {
    int *result; //pointer because RPC can only handle pointers as in & out args or return values
    //but in fact it is the value pointed to which is transmitted through the net
    struct timeval tv1, tv2;
    
#ifdef DEBUG
    printf("LocalServerStub::GetItsIntMember() %x\n", this);
#endif

    gettimeofday(&tv1,NULL);

    if ((result=getitsintmember_1(NULL,itsClientHandle)) == NULL) {
        clnt_perror(itsClientHandle, "serveur");
    }
    gettimeofday(&tv2,NULL);

// print Delay between sending the request and getting the result
    printf("Delay = %lds %ldus\n",tv2.tv_sec - tv1.tv_sec, tv2.tv_usec - tv1.tv_usec);
#ifdef DEBUG
        printf("LocalServerStub::GetItsIntMember()\n");
#endif
        return (*result); // *result since this method is supposed to return int value
}
