#include <rpc/rpc.h>
#include "example1.h"
#include "Server.h"

//This file contains all the remote procedures. they are named after the procedures declared in the .x file
//example: NEW_SERVER  -> new_server_1_svc

Server *itsServer;

extern "C" void *
new_server_1_svc(void *p, struct svc_req *s) {
    //p would contain pointers on input param, and s is used internally by rpc generated code
    
    void *ptr;
    static int a;
//ptr and a : only because it must return a void *, and NULL is interpreted as a connection failure by RPC
    // so I return a non-NULL pointer ...
    // SO NEVER RETURN NULL POINTER ON SUCCESS !!
    // RETURN VALUES MUST BE POINTERS ON STATIC VARIABLES !!
    ptr = (void *)&a;
    itsServer = new Server();
    return ptr;
}

extern "C" void *
delete_server_1_svc(void *p, struct svc_req *s) {
   void *ptr;
   //must be static !!
   static  int a;
    ptr = (void *)&a;
   
    delete itsServer;
    return ptr;
}

extern "C" int *getitsintmember_1_svc(void *p, struct svc_req *s) {
    //must be static !!
    static int integerVal;
    
    integerVal = itsServer->GetItsIntMember();
#ifdef DEBUG
    printf("RemoteServerStub: getitsintmember_1_svc; IntegerVal = %d\n",integerVal);
#endif
    // ALWAYS RETURN POINTERS !!!
    return (&integerVal);
}
