/* @(#)msg_proc.c	2.1 88/08/11 4.0 RPCSRC */
/*
 * msg_proc.c: implementation of the remote procedure "printmessage"
 */
#include <stdio.h>
#include <rpc/rpc.h>	/* always need this here */
#include "msg.h"	/* need this too: msg.h will be generated by rpcgen */

#ifdef PTHREAD_MUTEX_INITIALIZER /* MT-SAFE */
bool_t
printmessage_1_svc(char **argp, int *result, struct svc_req *rqstp)
{
    int retval;

    if (*argp == NULL) {
        syslog(LOG_INFO, "argp is NULL\n");
        *result = 0;
    }
    else {
        syslog("argp is %s\n", *argp);
        *result = strlen (*argp);
    }
    retval = 1;
    return (retval);
}

int
messageprog_1_freeresult(SVCXPRT *transp, xdrproc_t xdr_result, caddr_t result)
{
    /*
     * Insert additional freeing code here, if needed
     */
    (void) xdr_free(xdr_result, result);
}
#else /* !MT-SAFE */
/*
 * Remote verson of "printmessage"
 */
int *		
printmessage_1_svc(char **msg, struct svc_req *req)
{
	static int result; /* must be static! */
	FILE *f;

	f = fopen("/dev/console", "w");
	if (f == NULL) {
		result = 0;
		return (&result);
	}
	fprintf(f, "%s\n", *msg);
	fclose(f);
	result = 1;
	return (&result);
}
#endif
