#ifdef sun
#define  _REENTRANT
#endif
#include <stdio.h>
#include <rpc/rpc.h>
#include "operations.h"



struct thread_info {
    pthread_t client_id;
    int client_status;
};

struct client_info {
    char *host;
    char *protocol;
    bool_t is_a_thread;
};

struct thread_info save_thread[NTHREADS_CONST];
struct client_info save_clients[NTHREADS_CONST];

void *doclient(struct client_info*);

int
main(int argc, char **argv)
{
    int index, ret;
    int thread_status;
    int NTHREADS;
    char *protocol = "tcp";
    pthread_t client_id;
    char *host;
    if (argc < 2) {
        printf("Usage: do_operation [n] host [protocol]\n");
        printf("\twhere n is the number of threads\n");
        exit(1);
    } else
        if (argc == 2) {
            NTHREADS = NTHREADS_CONST;
            host = argv[1];  /* live_host */
        } else {
            NTHREADS = atoi(argv[1]);
            host = argv[2];
            if (argc == 4)
                protocol = argv[3];
        }
    for (index = 0; index < NTHREADS; index++){
        save_clients[index].host = host;
        save_clients[index].protocol = protocol;
        save_clients[index].is_a_thread = 1;
        if (ret = pthread_create(&client_id, NULL,
                                 (void*(*)(void*))doclient,
                                 (void *) &save_clients[index])) {
            printf("pthread_create failed: return value %d", ret);
            printf(" for %dth thread", index);
            printf(", reverting to threadless operation\n");
            save_clients[index].is_a_thread = 0;
            doclient(&save_clients[index]);
        }
        save_thread[index].client_id = client_id;
    }
    for (index = 0; index < NTHREADS; index++){
        if (pthread_join(save_thread[index].client_id,(void **)&thread_status)){
            printf("pthread_join failed for thread %d\n",
                   save_thread[index].client_id);
            exit(1);
        }
        save_thread[index].client_status = thread_status;
    }
}

void *
doclient(struct client_info *info)
{
    struct timeval tout;
    enum clnt_stat test;
    int result = 0;
    u_short mult_result = 0;
    int add_arg;
    int EXP_RSLT;
    intpair pair;
    CLIENT *clnt;
    if ((clnt = clnt_create(info->host, SVC2_PROG, SVC2_VERS, info->protocol)) == NULL) {
        clnt_pcreateerror("clnt_create error: ");
        if (info->is_a_thread)
            pthread_exit((void *) -1);
        return (void *) -1;
    }
    tout.tv_sec = 25;
    tout.tv_usec = 0;
    memset((char *) &result, 0, sizeof (result));
    memset((char *) &mult_result, 0, sizeof (mult_result));
    if ((unsigned int)pthread_self() % 2){
        EXP_RSLT = pthread_self() + 1;
        add_arg = pthread_self();
        test = clnt_call(clnt, SVC2_PROC_ADD, (xdrproc_t) xdr_int,
                         (caddr_t) &add_arg, (xdrproc_t) xdr_int, (caddr_t) &result,
                         tout);
        printf("thread %d (%s), ADD(%d)=%d\n",pthread_self(),info->protocol,
               add_arg,result);
    } else {
        pair.a = (u_short) pthread_self();
        pair.b = (u_short) 2;
        EXP_RSLT = pair.a * pair.b;
        test = clnt_call(clnt, SVC2_PROC_MULT, (xdrproc_t)
                         xdr_intpair,
                         (caddr_t) &pair, (xdrproc_t) xdr_u_short,
                         (caddr_t) &mult_result, tout);
        printf("thread %d (%s), MULT(%u,%u)=%u\n",pthread_self(),info->protocol,
               pair.a,pair.b,mult_result);
        result = mult_result;
    }
    if (test != RPC_SUCCESS) {
        printf("THREAD: %d clnt_call failed\n",pthread_self());
        if (info->is_a_thread)
            pthread_exit((void *) -1);
        return (void *) -1;
    };
    if (info->is_a_thread)
        pthread_exit((void *) 0);
    return (void *) 0;
}
