#define  _REENTRANT
#include <stdio.h>
#include <rpc/rpc.h>
#include <sys/uio.h>
#include <netconfig.h>
#include <netdb.h>
#include <rpc/nettype.h>
#include <thread.h>
#include "operations.h"

void *doclient(char *host);

int NTHREADS;

struct thread_info {
    thread_t client_id;
    int client_status;
};

struct thread_info save_thread[NTHREADS_CONST];

int
main(int argc, char **argv)
{
    int index, ret;
    int thread_status;
    thread_t departedid, client_id;
    char *hosts;
    if (argc < 2) {
        printf("Usage: do_operation [n] host\n");
        printf("\twhere n is the number of threads\n");
        exit(1);
    } else
        if (argc == 2) {
            NTHREADS = NTHREADS_CONST;
            hosts = argv[1];  /* live_host */
        } else {
            NTHREADS = atoi(argv[1]);
            hosts = argv[2];
        }
    for (index = 0; index < NTHREADS; index++){
        if (ret = thr_create(NULL, NULL, (void*(*)(void*))doclient,
                             (void *)  hosts, THR_BOUND, &client_id)){
            printf("thr_create failed: return value %d", ret);
            printf(" for %dth thread\n", index);
            exit(1);
        }
        save_thread[index].client_id = client_id;
    }
    for (index = 0; index < NTHREADS; index++){
        if (thr_join(save_thread[index].client_id, &departedid, 
                     (void *)
                     &thread_status)){
            printf("thr_join failed for thread %d\n",
                   save_thread[index].client_id);
            exit(1);
        }
        save_thread[index].client_status = thread_status;
    }
}

void *
doclient(char *host)
{
    struct timeval tout;
    enum clnt_stat test;
    int result = 0;
    u_short mult_result = 0;
    int add_arg;
    int EXP_RSLT;
    intpair pair;
    CLIENT *clnt;
    if ((clnt = clnt_create(host, SVC2_PROG, SVC2_VERS, "udp")) == NULL) {
        clnt_pcreateerror("clnt_create error: ");
        thr_exit((void *) -1);
    }
    tout.tv_sec = 25;
    tout.tv_usec = 0;
    memset((char *) &result, 0, sizeof (result));
    memset((char *) &mult_result, 0, sizeof (mult_result));
    if (thr_self() % 2){
        EXP_RSLT = thr_self() + 1;
        add_arg = thr_self();
        test = clnt_call(clnt, SVC2_PROC_ADD, (xdrproc_t) xdr_int,
                         (caddr_t) &add_arg, (xdrproc_t) xdr_int, (caddr_t) &result,
                         tout);
        printf("THREAD: %d ADD(%d)=%d\n",thr_self(),add_arg,result);
    } else {
        pair.a = (u_short) thr_self();
        pair.b = (u_short) 2;
        EXP_RSLT = pair.a * pair.b;
        test = clnt_call(clnt, SVC2_PROC_MULT, (xdrproc_t)
                         xdr_intpair,
                         (caddr_t) &pair, (xdrproc_t) xdr_u_short,
                         (caddr_t) &mult_result, tout);
        printf("THREAD: %d MULT(%u,%u)=%u\n",thr_self(),pair.a,pair.b,mult_result);
        result = mult_result;
    }
    if (test != RPC_SUCCESS) {
        printf("THREAD: %d clnt_call failed\n",thr_self());
        thr_exit((void *) -1);
    };
    thr_exit((void *) 0);
}

