#ifndef _LIBINTL_H
#ifdef ENABLE_NLS
#include <locale.h>

/* Now define the internal interfaces.  */
extern char *gettext (const char *msgid);
extern char *dgettext (const char *domainname,
			 const char *msgid);
extern char *dcgettext (const char *domainname,
			  const char *msgid, int category);
extern char *textdomain (const char *domainname);
extern char *bindtextdomain (const char *domainname,
			       const char *dirname);
extern char *bind_textdomain_codeset (const char *domainname,
					const char *codeset);
extern const char _libc_intl_domainname[];

/* Define the macros `_' and `N_' for conveniently marking translatable
   strings in the libc source code.  We have to make sure we get the
   correct definitions so we undefine the macros first.  */

# undef N_
# define N_(msgid)	msgid

# undef _
/* This is defined as an optimizing macro, so use it.  */
# define _(msgid) dcgettext (_libc_intl_domainname, (msgid), LC_MESSAGES)

#else
/* Stubs that do something close enough. */
#define textdomain(S) 0
#define gettext(S) (S)
#define dgettext(D,M) (M)
#define dcgettext(D,M,T) (M)
#define bindtextdomain(D,Dir) (D)
#define _(S) (S)
#define N_(S) S
#endif /* ENABLE_NLS */

#endif
