#ifndef	_RPC_FEATURES_H
#define	_RPC_FEATURES_H	1

/* Some user header file might have defined this before.  */
#undef	__P
#undef	__PMT

#ifdef __GNUC__

/* GCC can always grok prototypes.  For C++ programs we add throw()
   to help it optimize the function calls.  But this works only with
   gcc 2.8.x and egcs.  */
# if defined __cplusplus && (__GNUC__ >= 3 || __GNUC_MINOR__ >= 8)
#  define __THROW	throw ()
# else
#  define __THROW
# endif
#ifndef __P
# define __P(args)	args __THROW
#endif
/* This macro will be used for functions which might take C++ callback
   functions.  */
# define __PMT(args)	args
# define __DOTS		, ...

#else	/* Not GCC.  */

# define __inline		/* No inline functions.  */
# define __THROW
#define __attribute__(a)

# if (defined __STDC__ && __STDC__) || defined __cplusplus

#  define __P(args)	args
#  define __PMT(args)	args
#  define __const	const
#  define __signed	signed
#  define __volatile	volatile
#  define __DOTS	, ...

# else	/* Not ANSI C or C++.  */

#  define __P(args)	()	/* No prototypes.  */
#  define __PMT(args)	()
#  define __const		/* No ANSI C keywords.  */
#  define __signed
#  define __volatile
#  define __DOTS

# endif	/* ANSI C or C++.  */

#endif	/* GCC.  */

/* C++ needs to know that types and declarations are C, not C++.  */
#ifdef	__cplusplus
# define __BEGIN_DECLS	extern "C" {
# define __END_DECLS	}
#else
# define __BEGIN_DECLS
# define __END_DECLS
#endif

/* It is possible to compile containing GCC extensions even if GCC is
   run in pedantic mode if the uses are carefully marked using the
   `__extension__' keyword.  But this is not generally available before
   version 2.8.  */
#if !defined __GNUC__ || __GNUC__ < 2 || (__GNUC__ == 2 && __GNUC_MINOR__ < 8)
# define __extension__		/* Ignore */
#endif

/* __restrict is known in EGCS 1.2 and above. */
#if !defined __GNUC__ || __GNUC__ < 2 || (__GNUC__ == 2 && __GNUC_MINOR__ < 92)
# define __restrict	/* Ignore */
#endif

#if defined(__sun__) || defined(sun)
#define __need___uid_t
#define __need___gid_t
#define __need_u_int32_t
#define __need_quad_t
#define __need_u_quad_t
#endif

#if defined(__CYGWIN__)
#define __need___uid_t
#define __need___gid_t
#define __need_uint8_t
#define __need_uint16_t
#define __need_uint32_t
#define __need_uint64_t
#define __need_quad_t
#define __need_u_quad_t
#ifndef _SYS_CDEFS_H
#undef __P
#include <sys/cdefs.h>
#endif
#endif

#ifdef INSIDE_RPCLIB

#include <libc-symbols.h>

#undef text_set_element
#define text_set_element(a,b)

/* cygwin hacks */
#ifndef linux
/* don't include rpc/netdb.h since rpcent is defined in netdb.h */
#ifdef __CYGWIN__
#define _RPC_NETDB_H 1
/* cygwin msghdr doesn't have msg_flags */
#endif
#ifndef MIN
#define MIN(a,b) (a)<(b)?(a):(b)
#endif
#define __fork fork
#define __dup dup
#define __pipe pipe
#define __fdopen fdopen
#define __fcntl fcntl
#define __wait4 wait4
#define __sigprocmask sigprocmask
#define __setreuid setreuid
#define __getuid getuid
#ifndef __bzero
#define __bzero bzero
#endif
#endif

#ifndef HAVE_STRERROR_R
#define strerror_r(a,b,c) strerror(a)
#endif

#ifndef HAVE_SETREUID
#define setreuid(a,b) (-1)
#endif

#ifdef HAVE_YP_MATCH
#define SECURE_RPC
#endif

#define __socket socket
#define __getpid getpid
#define __lseek lseek
#define __open open
#define __close close
#define __ioctl ioctl
#define __poll poll
#define __connect connect
#define __read read
#define __write write
#define __gettimeofday gettimeofday
#define __getdtablesize getdtablesize
#define __set_errno(e) errno = e
#define __sysconf sysconf
#define __gethostname gethostname
#define __geteuid geteuid
#define __getegid getegid
#define __getgroups getgroups
#define __gethostbyname_r gethostbyname_r
#define __strerror_r strerror_r
#define __srand48_r srand48_r
#define __getpeername getpeername
#define __getprotobyname_r getprotobyname_r

#endif /* INSIDE_RPCLIB */

#endif	/* rpc/features.h  */
