/*
 * Sun RPC is a product of Sun Microsystems, Inc. and is provided for
 * unrestricted use provided that this legend is included on all tape
 * media and as a part of the software program in whole or part.  Users
 * may copy or modify Sun RPC without charge, but are not authorized
 * to license or distribute it to anyone else except as part of a product or
 * program developed by the user.
 *
 * SUN RPC IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING THE
 * WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR TRADE PRACTICE.
 *
 * Sun RPC is provided with no support and without any obligation on the
 * part of Sun Microsystems, Inc. to assist in its use, correction,
 * modification or enhancement.
 *
 * SUN MICROSYSTEMS, INC. SHALL HAVE NO LIABILITY WITH RESPECT TO THE
 * INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY SUN RPC
 * OR ANY PART THEREOF.
 *
 * In no event will Sun Microsystems, Inc. be liable for any lost revenue
 * or profits or other special, indirect and consequential damages, even if
 * Sun has been advised of the possibility of such damages.
 *
 * Sun Microsystems, Inc.
 * 2550 Garcia Avenue
 * Mountain View, California  94043
 */
/* fixincludes should not add extern "C" to this file */
/*
 * Rpc additions to <sys/types.h>
 */
#ifndef _RPC_TYPES_H
#define _RPC_TYPES_H 1

#include <rpc/features.h>

typedef int bool_t;
typedef int enum_t;
/* This needs to be changed to uint32_t in the future */
typedef unsigned long rpcprog_t;
typedef unsigned long rpcvers_t;
typedef unsigned long rpcproc_t;
typedef unsigned long rpcprot_t;
typedef unsigned long rpcport_t;

#define        __dontcare__    -1

#ifndef FALSE
#      define  FALSE   (0)
#endif

#ifndef TRUE
#      define  TRUE    (1)
#endif

#ifndef NULL
#      define  NULL 0
#endif

#include <stdlib.h>		/* For malloc decl.  */
#define mem_alloc(bsize)	malloc(bsize)
#define mem_free(ptr, bsize)	free(ptr)

#ifndef makedev /* ie, we haven't already included it */
#include <sys/types.h>
#endif
#include <sys/time.h>
#include <sys/param.h>

#include <netinet/in.h>
#include <netdb.h>

#ifndef INADDR_LOOPBACK
#define       INADDR_LOOPBACK         (u_long)0x7F000001
#endif
#ifndef MAXHOSTNAMELEN
#define        MAXHOSTNAMELEN  64
#endif

#ifdef __need_quad_t
#ifdef __GNUC__
__extension__ typedef long long int quad_t;
#else
typedef struct
  {
    long int __val[2];
  } quad_t;
#endif
#undef __need_quad_t
#endif

#ifdef __need_u_quad_t
#ifdef __GNUC__
__extension__ typedef unsigned long long int u_quad_t;
#else
typedef struct
  {
    u_long __val[2];
  } u_quad_t;
#endif
#undef __need_u_quad_t
#endif

#ifdef __need___uid_t
typedef uid_t __uid_t;
#undef __need___uid_t
#endif

#ifdef __need___gid_t
typedef gid_t __gid_t;
#undef __need___gid_t
#endif

#ifdef __need_uint8_t
typedef unsigned char uint8_t;
#undef __need_uint8_t
#endif

#ifdef __need_uint16_t
typedef unsigned short uint16_t;
#undef __need_uint16_t
#endif

#ifdef __need_uint32_t
typedef unsigned int uint32_t;
#undef __need_uint32_t
#endif

#ifdef __need_u_int32_t
typedef uint32_t u_int32_t;
#undef __need_u_int32_t
#endif

#ifdef __need_int64_t
typedef quad_t int64_t;
#undef __need_int64_t
#endif

#ifdef __need_uint64_t
typedef quad_t uint64_t;
#undef __need_uint64_t
#endif

#endif /* rpc/types.h */
