#include <stdlib.h>
#include <sys/socket.h>
#include <sys/errno.h>

#ifndef HAVE_STRUCT_IOVEC
struct iovec {
  void          *iov_base;
  size_t         iov_len;
};
#endif

ssize_t
sendmsg(int s, const struct msghdr *msg, int flags)
{
    ssize_t ret;
    size_t tot = 0;
    int i;
    char *buf, *p;
    struct iovec *iov = msg->msg_iov;

    for(i = 0; i < msg->msg_iovlen; ++i)
	tot += iov[i].iov_len;
    buf = malloc(tot);
    if (tot != 0 && buf == NULL) {
	errno = ENOMEM;
	return -1;
    }
    p = buf;
    for (i = 0; i < msg->msg_iovlen; ++i) {
	memcpy (p, iov[i].iov_base, iov[i].iov_len);
	p += iov[i].iov_len;
    }
    ret = sendto (s, buf, tot, flags, msg->msg_name, msg->msg_namelen);
    free (buf);
    return ret;
}
